with Interfaces; use Interfaces;

package body CORBA_Repository_Root_ExtAttributeDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 6, 10);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (31, 3, 53, 31);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (9, 55, 55, 36);

   G : constant array (0 .. 56) of Unsigned_8 :=
     (2, 25, 0, 15, 0, 0, 17, 17, 10, 14, 10, 0, 0, 11, 6, 7, 0, 14, 0, 1,
      22, 0, 0, 11, 0, 0, 0, 8, 0, 0, 17, 25, 0, 0, 0, 15, 0, 17, 0, 4, 0,
      0, 0, 10, 0, 19, 0, 0, 3, 0, 0, 0, 0, 2, 14, 0, 16);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 57;
         F2 := (F2 + Natural (T2 (K)) * J) mod 57;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 28;
   end Hash;

end CORBA_Repository_Root_ExtAttributeDef_Hash;
